package net.shadowfacts.asmr.program.blocks

import net.shadowfacts.asmr.program.ExecutableBlock
import net.shadowfacts.asmr.program.ProgramBlockInput
import net.shadowfacts.asmr.program.ProgramBlockOutput
import net.shadowfacts.asmr.program.ProgramType
import net.shadowfacts.cacao.geometry.Point

/**
 * @author shadowfacts
 */
class PrintBlock<Type: Any>(
		val type: ProgramType<Type>
): ExecutableBlock() {

	val input = ProgramBlockInput(type, this)

	override val inputs: Array<ProgramBlockInput<*>> = arrayOf(input)
	override val outputs: Array<ProgramBlockOutput<*>> = arrayOf()

	override fun execute() {
		println(input.value)
	}

}